/*
     copyright        : (C) 2002,2003 by Jonas Genannt only the modification.
                      : (C) calle, look at capiconn.c and capiconn.h
     email            : jonasge@gmx.net
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   any later version.                                                    *
 *                                     *
 ***************************************************************************/
/*
Jonas Genannt <jonasge@gmx.net>
Orginal from calle    calle@calle.in-berlin.de
*/

#include <stdio.h>
#include <malloc.h>
#include <stdlib.h>
#include <getopt.h>
#include "capiconn.h"
#include <string.h>
#define MAIN
#include  "capi.h"
/*#include "config_api.h"*/

 char *command = "capitotext";
 char *version = "0.19";
 char rufnummer[1024]="";
 char a_rufnummer[20][80];

 struct tm *zgr;
 char ptime[80],pdate[80], rufnr[80]="";
 char respond_buffer[300]="";
// char old_buffer[300]="";
 time_t jetzt;
        
        
/* -------------------------------------------------------------------- */

static int opt_debug = 0;
static int opt_verbose = 0;
static char *opt_ddi = 0;
static char opt_ndigits = 0;
static int opt_contr = 1;
static int opt_reject = 0;
static int opt_ignore = 0;
static int opt_alert = 0;
static char *opt_conf ="/etc/capitotext.conf";
int cmp;
static void usage(void)
{
    fprintf(stderr, "CAPITOTEXT v%s - report incomming calls\n", version);
    fprintf(stderr, "\n");
    fprintf(stderr, "Usage: capitotext [CAPIOPTION]\n");
    fprintf(stderr, "\n");
    fprintf(stderr, "CAPIOPTIONS:\n");
    fprintf(stderr, "   -c, --controller contr (default %d)\n", opt_contr);
    fprintf(stderr, "   -d, --debug\n");
    fprintf(stderr, "   -h, --help\n");
    fprintf(stderr, "   -v, --verbose\n");
//    fprintf(stderr, "   -C config-file  (default /etc/capitotext.conf)\n");
}

/* -------------------------------------------------------------------- */

static char msgbuf[4096];

void vxerrmsg(const char *prefix, const char *suffix,
        const char *format, va_list args)
{
   char *s = msgbuf;
   char *e = msgbuf + sizeof(msgbuf);

   (void)snprintf(s, e-s, "%s: %s", command, prefix);
   s += strlen(s);
   (void)vsnprintf(s, e-s, format, args);
   s += strlen(s);
   (void)snprintf(s, e-s, "%s", suffix);
   s += strlen(s);

   fprintf(stderr, "%s\n", msgbuf);
}

void errmsg(const char *format, ...)
{
   va_list args;

   va_start(args, format);
   vxerrmsg("Error: ", "", format, args);
   va_end(args);
}

void infomsg(const char *format, ...)
{

   va_list args;
   if (!opt_verbose) return;

   va_start(args, format);
   vxerrmsg("Info: ", "", format, args);
   va_end(args);
   
}

void debugmsg(const char *format, ...)
{
   va_list args;

   if (!opt_debug) return;

   va_start(args, format);
   vxerrmsg("Debug: ", "", format, args);
   va_end(args);
}

/* -------------------------------------------------------------------- */

static char *conninfo(capi_connection *p)
{
    static char buf[1024];
    capi_conninfo *cp = capiconn_getinfo(p);

/*  snprintf(buf, sizeof(buf),
            "appl=%d plci=0x%x ncci=0x%x %s",
            cp->appid,
            cp->plci,
            cp->ncci,
            cp->isincoming ? "incoming" : "outgoing"
            );
*/
    snprintf(buf,sizeof(buf), cp->isincoming ? "incoming" : "outgoing");        
    return buf;
}

static void disconnected(capi_connection *cp,
                int localdisconnect,
                unsigned reason,
                unsigned reason_b3)
{
/*  infomsg("disconnected(%s): %s: 0x%04x (0x%04x) - %s", 
            conninfo(cp),
            localdisconnect ? "local" : "remote",
            reason, reason_b3, capi_info2str(reason));
*/
}

static void incoming(capi_connection *cp,
              unsigned contr,
              unsigned cipvalue,
              char *callednumber,
              char *callingnumber)
{
  //int y=0;
    int dienstkennung = 0;

    switch (cipvalue) {
        case 1: /* Speech */
            dienstkennung=1;
            break;

        case 2: /* Daten Standard */
            dienstkennung=2;
            break;

        case 3: /* Daten Restricted */
            dienstkennung=3;
            break;

        case 4: /* Sprache 3,1kHz */
            dienstkennung=4;
            break;

        case 5: /* Sprache 7 KHz */
            dienstkennung=5;
            break;

        case 6: /* Video */
            dienstkennung=6;
            break;

        case 7: /* Packet Mode */
            dienstkennung=7;
            break;

        case 8: /* Adaptive 56kbit/s */
            dienstkennung=8;
            break;

        case 9: /* Daten und Ansagen */
            dienstkennung=9;
            break;

        case 16: /* Sprache Digital */
            dienstkennung=16;
            break;

        case 17: /* Fax G2/G3 */
            dienstkennung=17;
            break;

        case 18: /* Fax G4-I */
            dienstkennung=18;
            break;

        case 19: /* Fax G4-II/III */
            dienstkennung=19;
            break;

        case 20: /* Telex */
            dienstkennung=20;
            break;

        case 21: /* Telex */
            dienstkennung=21;
            break;

        case 22: /* Telex */
            dienstkennung=22;
            break;

        case 23: /* Videotex */
            dienstkennung=23;
            break;

        case 24: /* X.400/E-Mail */
            dienstkennung=24;
            break;

        case 25: /* X.200/OSI */
            dienstkennung=25;
            break;

        case 26: /* Sprache 7kHz */
            dienstkennung=26;
            break;

        case 27: /* Videotelefon L1 */
            dienstkennung=27;
            break;

        case 28: /* Videotelefon L2 */
            dienstkennung=28;
            break;

        default: /* Fehlerfall unbekannt */
            dienstkennung=99;
            (void)capiconn_ignore(cp);
            break;
    }

    time(&jetzt);
    zgr=localtime(&jetzt);
    strftime(ptime,80, "%H:%M:%S",zgr);
    strftime(pdate,80, "%Y-%m-%d",zgr);

    // read dienstekennung from callingnumber string
    unsigned char cid = callingnumber[0];
    char callingindicator = 0;        // set default: unknown

    if (cid & 32)                     // check if bit 6 has been set -> 0x20 - national
        callingindicator = 2;
    else if (cid & 16)                // check if bit 5 has been set -> 0x10 - international
        callingindicator = 1;

    callingnumber += 2;               // remove first two bytes from callingnumber

    debugmsg("callingindicator: %d", callingindicator);
    debugmsg("callingnumber   : %s", callingnumber);

    if (!strcmp("0", callingnumber))
    {
      sprintf(callingnumber, "unbekannt");
       }
    if (!strcmp("", callingnumber))
    {
      sprintf(callingnumber, "unbekannt");
    }
            
    sprintf(respond_buffer, "capi2text.sh %s %s %s %s %i %i",pdate,ptime,callingnumber,callednumber,callingindicator,dienstkennung);
    system(respond_buffer );
    respond_buffer[0]='\0';
}

static void connected(capi_connection *cp, _cstruct NCPI)
{
    infomsg("connected(%s) NCPIlen=%d", conninfo(cp), NCPI[0]);
}

static void received(capi_connection *cp,
                unsigned char *data,
                unsigned datalen)
{
    infomsg("received(%s): %p len=%u", conninfo(cp), data, datalen);
}

static void datasent(capi_connection *cp, unsigned char *buf)
{
    infomsg("sent hier(%s): %p (%p)", conninfo(cp), buf);
}

static void chargeinfo(capi_connection *cp,
               unsigned long charge, int inunits)
{
    infomsg("chargeinfo(%s): %ld %s",
        conninfo(cp), charge, inunits ? "Units" : "Currency");
}

void put_message(unsigned appid, unsigned char *msg)
{
    unsigned err;
    debugmsg(">>> %s", capi_message2str(msg));
    err = capi20_put_message (appid, msg);
    if (err)
        errmsg("putmessage(appid=%u) = 0x%x", appid, err);
}

/* -------------------------------------------------------------------- */

capiconn_callbacks callbacks = {
    malloc: malloc,
    free: free,

    disconnected: disconnected,
    incoming: incoming,
    connected: connected,
    received: received, 
    datasent: datasent, 
    chargeinfo: chargeinfo,

    capi_put_message: put_message,

    debugmsg: debugmsg,
    infomsg: infomsg,
    errmsg: errmsg
};

static capiconn_context *ctx;


int main(int ac, char *av[])
{
    static capi_contrinfo cinfo = { 0 , 0, 0 };
    unsigned err;
    unsigned applid;
    int c;
//int i=1;
//int e=0;
//char nbuffer[1024]="";
//char komma=',';

//size_t laenge;
//char buffer[1024]="";


    for (;;) {
           int option_index = 0;
           static struct option long_options[] = {
               {"controller", 1, 0, 'c'},
               {"debug", 0, 0, 'd'},
               {"help", 0, 0, 'h'},
               {"verbose", 0, 0, 'v'},
//             {"reject", 0, 0, 'r'},
//             {"ignore", 0, 0, 'i'},
//             {"alert", 0, 0, 'a'},
               {0, 0, 0, 0}
           };

           c = getopt_long (ac, av, "c:C:dD:hH:vV:",
                   long_options, &option_index);
           if (c == -1)
               break;

           switch (c) {
               case 0:
                   printf ("option %s",
                       long_options[option_index].name);
                   if (optarg)
                       printf (" with arg %s", optarg);
                   printf ("\n");
                   break;
               case 'c':
                   opt_contr = atoi(optarg);
                   break;
               case 'd':
                   opt_debug = 1;
                   break;
               case 'h':
                   usage();
                   return 1;
                   break;
               case 'v':
                   opt_verbose = 1;
                   break;
               case 'D':
                   opt_ddi = optarg;
                   break;
               case 'C':
                   opt_conf = optarg;
                   break;
               case 'i':
                   opt_ignore = 1;
                   break;
               case 'r':
                   opt_reject = 1;
                   break;
               case 'a':
                   opt_alert = 1;
                   break;
//             case '?':
//                 usage();
//                 return 1;
               default :
                   break;
           }
    }
    opt_alert = 1;
    if (optind != ac) {
        errmsg("too many arguments");
            usage();
        return 1;
    }

    if ((err = capi20_register (30, 8, 2048, &applid)) != 0) {
        errmsg("CAPI_REGISTER failed - 0x%04x");
        return 2;
        }
    ctx = capiconn_getcontext(applid, &callbacks);

    cinfo.ddi = opt_ddi;
    cinfo.ndigits = opt_ndigits;
    (void)capiconn_addcontr(ctx, opt_contr, &cinfo);
    (void)capiconn_listen(ctx, opt_contr, 0x1FFF03FF, 0);

    for (;;) {
        unsigned char *msg = 0;
        if (capi20_waitformessage(applid, 0) == 0) {
            if (capi20_get_message (applid, &msg) == 0) {
                if (opt_debug)
                    debugmsg("<<< %s", capi_message2str(msg));
                capiconn_inject(applid, msg);
            }
        }
        /*infomsg("loop");*/
    }
}
